/************************************************************************
 *            CUORE IMMACOLATO DI MARIA E SANT'ILARIO PARISH            *
 *                     MADONNA PELLEGRUNA SANCTUARY                     *
 *                          ROVIGO - COMMENDA                           *
 *                                                                      *
 *                           CRYPT TABERNACLE                           *
 ************************************************************************/

#include "descriptor/descriptor.h"	/* Descriptor Library.		*/

/* Main Function.							*/

int main(void)
{
    ITEM circle,
         crypt, floor, floor_a,
                front_wall, front_wall_a,
		side_wall, side_wall_a,
		cross, cross_a,
		mirror, mirror_surface, mirror_surface_a,
		        mirror_border, mirror_border_a,
		door, door_a,
	 altar, table, table_a,
	        leg1, leg2, leg3, leg4, leg_a,
	 tabernacle, ciborium, ciborium_a,
	             cover, cover_a,
		     wing, wing_a,
	 dish1, dish2, dish3, dish4, dish, dish_a,
	 host, host_a,
	 chalice, chalice_a,
	 wine, wine_a,
	 candle0, candle1, candle_wick, candle_wick_a,
	                   flame, flame_a,
	 plant, vase, vase_a,
	        earth, earth_a,
		leaves, leaves_a,
	 scene;
    
    /* BackGround and Lights.						*/
    set_background(1.0, 1.0, 1.0, TRUE);
    set_ambient_light(1.0, 1.0, 1.0, 0.5);
    create_distant_light(-1.0, -4.0, -1.0,
                         1.0, 1.0, 1.0,
			 0.5, "Distant-Light");
    create_point_light(0.6, -1.28, -0.68,
                       1.0, 1.0, 0.0,
		       1.0, 0.0, "Light-Candle-0");
    create_point_light(-0.6, -1.28, -0.68,
                       1.0, 1.0, 0.0,
		       1.0, 0.0, "Light-Candle-1");
    
    /*
     * Circle (used for the Host in the Dish, the Wine in the Chalice
     * and the Earth in the Vase).
     */
    
    circle = read_nurbs("circle_s.db");
    
    /* Crypt.								*/
    
    /* Floor.								*/
    
    floor_a = create_attribute("Floor-Attributes");
    
    set_color(floor_a, 1.0, 1.0, 0.5, 0.3, 0.7);
    set_reflectivity(floor_a, 0.4, 2.0);
    
    floor = read_nurbs("floor_s.db");
    
    set_attribute(floor, floor_a);
    set_scale(floor, 2.0, 2.0, 2.0);
    set_domain_texture(floor, floor_a, "textures/tiles.hr",
                       0.0, 0.125, 0.0, 0.125, 1, 0.3, 0.7);
    
    crypt = create_list(floor, "Crypt");
    
    /* Front Wall.							*/
    
    front_wall_a = create_attribute("Front-Wall-Attributes");
    
    set_color(front_wall_a, 1.0, 1.0, 1.0, 0.3, 0.7);
    set_reflectivity(front_wall_a, 0.0, 2.0);
    
    front_wall = read_nurbs("wall_front_s.db");
    
    set_attribute(front_wall, front_wall_a);
    set_scale(front_wall, 2.0, 2.0, 2.0);
    set_bump_texture(front_wall, front_wall_a, "textures/marble.hr",
                     0.0, 0.25, 0.0, 0.25, 1, 1.0, 1.0);
    
    crypt = insert_in_list(crypt, front_wall);
    
    /* Side Wall.							*/
    
    side_wall_a = create_attribute("Side-Wall-Attributes");
    
    set_color(side_wall_a, 1.0, 0.75, 0.5, 0.3, 0.7);
    set_reflectivity(side_wall_a, 0.0, 2.0);
    
    side_wall = read_nurbs("wall_side_s.db");
    
    set_attribute(side_wall, side_wall_a);
    set_scale(side_wall, 2.0, 2.0, 2.0);
    set_domain_texture(side_wall, side_wall_a, "textures/bricks.hr",
                       0.0, 0.5, 0.0, 0.5, 1, 0.3, 0.7);
    
    crypt = insert_in_list(crypt, side_wall);
    
    /* Cross.								*/
    
    cross_a = create_attribute("Cross-Attributes");
    
    set_color(cross_a, 0.5, 0.25, 0.0, 0.3, 0.7);
    set_reflectivity(cross_a, 0.0, 2.0);
    
    cross = read_obj("cross.obj", "Cross");
    
    set_attribute(cross, cross_a);
    set_translate(cross, 0.0, -1.92, 0.48);
    set_domain_texture(cross, cross_a, "textures/wood.hr",
                       0.0, 1.0, 0.0, 1.0, 1, 0.3, 0.7);
    
    crypt = insert_in_list(crypt, cross);
    
    /* Mirror.								*/
    
    /* Mirror Surface.							*/
    
    mirror_surface_a = create_attribute("Mirror-Surface-Attributes");
    
    set_color(mirror_surface_a, 0.0, 0.0, 0.0, 1.0, 1.0);
    set_reflectivity(mirror_surface_a, 1.0, 128.0);
    
    mirror_surface = read_nurbs("mirror_surface_s.db");
    
    set_attribute(mirror_surface, mirror_surface_a);
    set_scale(mirror_surface, 0.4, 0.4, 0.4);
    set_z_rotate_abs(mirror_surface, 90.0, 1);
    set_translate(mirror_surface, -1.92, -1.0, -0.5);
    
    mirror = create_list(mirror_surface, "Mirror");
    
    /* Mirror Border.							*/
    
    mirror_border_a = create_attribute("Mirror-Border-Attributes");
    
    set_color(mirror_border_a, 1.0, 0.5, 0.0, 0.3, 0.7);
    set_reflectivity(mirror_border_a, 0.0, 2.0);
    
    mirror_border = read_obj("mirror_border.obj", "Mirror-Border");
    
    set_attribute(mirror_border, mirror_border_a);
    set_scale(mirror_border, 0.4, 0.4, 0.4);
    set_z_rotate_abs(mirror_border, 90.0, 1);
    set_translate(mirror_border, -1.92, -1.0, -0.5);
    set_domain_texture(mirror_border, mirror_border_a, "textures/wood.hr",
                       0.0, 1.0, 0.0, 1.0, 1, 0.3, 0.7);
    
    mirror = insert_in_list(mirror, mirror_border);
    
    crypt = insert_in_list(crypt, mirror);
    
    /* Door.								*/
    
    door_a = create_attribute("Door-Attributes");
    
    set_color(door_a, 0.5, 0.25, 0.0, 0.3, 0.7);
    set_reflectivity(door_a, 0.0, 2.0);
    
    door = read_nurbs("door_s.db");
    
    set_attribute(door, door_a);
    set_translate(door, -1.92, 0.4, -0.75);
    set_domain_texture(door, door_a, "textures/door.hr",
                       0.0, 1.0, 0.0, 1.0, 1, 0.3, 0.7);
    
    crypt = insert_in_list(crypt, door);
    
    scene = create_list(crypt, "Scene");
    
    /* Altar.								*/
    
    /* Table.								*/
    
    table_a = create_attribute("Table-Attributes");
    
    set_color(table_a, 0.75, 1.0, 1.0, 0.3, 0.7);
    set_reflectivity(table_a, 0.1, 2.0);
    set_transparency(table_a, 0.8, 0.4, 3, 1.66);
    
    table = read_obj("table.obj", "Table");
    
    set_attribute(table, table_a);
    set_scale(table, 2.0, 2.0, 2.0);
    set_translate(table, 0.0, -1.0, -1.08);
    
    altar = create_list(table, "Altar");
    
    /* Legs.								*/
    
    leg_a = create_attribute("Leg-Attributes");
    
    set_color(leg_a, 0.5, 0.25, 0.0, 0.3, 0.7);
    set_reflectivity(leg_a, 0.0, 2.0);
    
    leg1 = read_obj("leg.obj", "Leg-1");
    
    set_attribute(leg1, leg_a);
    set_scale(leg1, 0.5, 0.5, 0.5);
    set_translate(leg1, 0.6, -0.72, -1.581);
    
    altar = insert_in_list(altar, leg1);
    
    leg2 = create_copy(leg1, "Leg-2");
    
    set_translate(leg2, 0.0, -0.56, 0.0);
    
    altar = insert_in_list(altar, leg2);
    
    leg3 = create_copy(leg2, "Leg-3");
    
    set_z_rotate_abs(leg3, 180.0, 1);
    set_scale(leg3, 0.5, 0.5, 0.5);
    set_translate(leg3, -0.5, -0.72, -1.581);
    
    altar = insert_in_list(altar, leg3);
    
    leg4 = create_copy(leg3, "Leg-4");
    
    set_translate(leg4, 0.0, -0.56, 0.0);
    
    altar = insert_in_list(altar, leg4);
    
    scene = insert_in_list(scene, altar);
    
    /* Tabernacle.							*/
    
    /* Ciborium.							*/
    
    ciborium_a = create_attribute("Ciborium-Attributes");
    
    set_color(ciborium_a, 1.0, 1.0, 1.0, 0.3, 0.7);
    set_reflectivity(ciborium_a, 0.1, 2.0);
    
    ciborium = read_nurbs("ciborium_s.db");
    
    set_attribute(ciborium, ciborium_a);
    set_domain_texture(ciborium, ciborium_a, "textures/marble.hr",
                       0.0, 0.2, 0.0, 0.2, 1, 0.3, 0.7);
    
    tabernacle = create_list(ciborium, "Tabernacle");
    
    /* Cover.								*/
    
    cover_a = create_attribute("Cover-Attributes");
    
    set_color(cover_a, 1.0, 1.0, 0.5, 0.3, 0.7);
    set_reflectivity(cover_a, 0.4, 2.0);
    
    cover = read_nurbs("cover_s.db");
    
    set_attribute(cover, cover_a);
    set_translate(cover, 0.0, 0.0, 0.55);
    set_bump_texture(cover, cover_a, "textures/metal.hr",
                     0.0, 0.4, 0.0, 0.4, 1, 0.04, -0.4);
    
    tabernacle = insert_in_list(tabernacle, cover);
    
    /* Wing.								*/
    
    wing_a = create_attribute("Wing-Attributes");
    
    set_color(wing_a, 1.0, 1.0, 0.5, 0.3, 0.7);
    set_reflectivity(wing_a, 0.4, 2.0);
    
    wing = read_nurbs("wing_s.db");
    
    set_attribute(wing, wing_a);
    set_translate(wing, 0.0, 0.5, 0.0);
    set_bump_texture(wing, wing_a, "textures/metal.hr",
                     0.0, 0.4, 0.0, 0.4, 1, 0.04, -0.4);
    
    tabernacle = insert_in_list(tabernacle, wing);
    
    set_scale(tabernacle, 0.48, 0.48, 0.48);
    set_translate(tabernacle, 0.0, -1.28, -0.76);
    
    scene = insert_in_list(scene, tabernacle);
    
    /* Host.								*/
    
    host_a = create_attribute("Host-Attributes");
    
    set_color(host_a, 1.0, 1.0, 0.75, 0.3, 0.7);
    set_reflectivity(host_a, 0.0, 2.0);
    
    host = create_copy(circle, "Host");
    
    set_attribute(host, host_a);
    set_scale(host, 0.16, 0.16, 0.16);
    set_y_rotate(host, 9.0, 1);
    set_translate(host, 0.16, -0.72, -0.96);
    
    scene = insert_in_list(scene, host);
    
    /* Chalice.								*/
    
    chalice_a = create_attribute("Chalice-Attributes");
    
    set_color(chalice_a, 1.0, 1.0, 0.5, 0.3, 0.7);
    set_reflectivity(chalice_a, 0.1, 2.0);
    
    chalice = read_obj("chalice.obj", "Chalice");
    
    set_attribute(chalice, chalice_a);
    set_scale(chalice, 0.24, 0.24, 0.24);
    set_translate(chalice, -0.2, -0.72, -0.86);
    
    scene = insert_in_list(scene, chalice);
    
    /* Wine.								*/
    
    wine_a = create_attribute("Wine-Attributes");
    
    set_color(wine_a, 0.75, 0.0, 0.0, 0.3, 0.7);
    set_reflectivity(wine_a, 0.1, 2.0);
    
    wine = create_copy(circle, "Wine");
    
    set_attribute(wine, wine_a);
    set_scale(wine, 0.15, 0.15, 0.15);
    set_translate(wine, -0.2, -0.72, -0.716);
    
    scene = insert_in_list(scene, wine);
    
    /* Dishes.								*/
    
    dish_a = create_attribute("Dish-Attributes");
    
    set_color(dish_a, 1.0, 0.75, 0.5, 0.3, 0.7);
    set_reflectivity(dish_a, 0.0, 2.0);
    
    dish = read_nurbs("dish_s.db");
    
    set_attribute(dish, dish_a);
    set_scale(dish, 0.16, 0.16, 0.16);
    set_translate(dish, 0.2, -0.72, -0.99);
    
    dish1 = create_copy(dish, "Dish-1");
    
    scene = insert_in_list(scene, dish1);
    
    dish2 = create_copy(dish1, "Dish-2");
    
    set_translate(dish2, 0.4, -0.56, 0.0);
    
    scene = insert_in_list(scene, dish2);
    
    dish3 = create_copy(dish1, "Dish-3");
    
    set_translate(dish3, -0.8, -0.56, 0.0);
    
    scene = insert_in_list(scene, dish3);
    
    dish4 = create_copy(dish1, "Dish-4");
    
    set_scale(dish4, 2.0, 2.0, 2.0);
    set_translate(dish4, -0.4, 1.0, 0.0);
    
    scene = insert_in_list(scene, dish4);
    
    /* Candles.								*/
    
    /* Candle and Wick.							*/
    
    candle_wick_a = create_attribute("Candle-Wick-Attributes");
    
    set_color(candle_wick_a, 1.0, 0.0, 0.0, 0.3, 0.7);
    set_reflectivity(candle_wick_a, 0.0, 2.0);
    
    candle_wick = read_obj("candle_wick.obj", "Candle-Wick");
    
    set_attribute(candle_wick, candle_wick_a);
    set_scale(candle_wick, 0.25, 0.25, 0.25);
    set_translate(candle_wick, 0.6, -1.28, -0.87);
    
    candle0 = create_list(candle_wick, "Candle-0");
    
    /* Flame.								*/
    
    flame_a = create_attribute("Flame-Attributes");
    
    set_color(flame_a, 1.0, 1.0, 0.5, 1.0, 1.0);
    set_reflectivity(flame_a, 0.0, 2.0);
    set_transparency(flame_a, 0.8, 0.4, 3, 1.66);
    
    flame = read_nurbs("flame_s.db");
    
    set_attribute(flame, flame_a);
    set_scale(flame, 1.28, 1.28, 1.28);
    set_translate(flame, 0.6, -1.28, -0.68);
    
    candle0 = insert_in_list(candle0, flame);
    
    scene = insert_in_list(scene, candle0);
    
    candle1 = create_copy(candle0, "Candle-1");
    
    set_translate(candle1, -1.2, 0.0, 0.0);
    
    scene = insert_in_list(scene, candle1);
    
    /* Plant.								*/
    
    /* Vase.								*/
    
    vase_a = create_attribute("Vase-Attributes");
    
    set_color(vase_a, 0.75, 0.5, 0.25, 0.3, 0.7);
    set_reflectivity(vase_a, 0.0, 2.0);
    
    vase = read_nurbs("vase_s.db");
    
    set_attribute(vase, vase_a);
    set_scale(vase, 0.4, 0.4, 0.4);
    set_translate(vase, 0.0, -0.44, -1.84);
    
    plant = create_list(vase, "Plant");
    
    /* Earth.								*/
    
    earth_a = create_attribute("Earth-Attributes");
    
    set_color(earth_a, 0.5, 0.25, 0.0, 0.3, 0.7);
    set_reflectivity(earth_a, 0.0, 2.0);
    
    earth = create_copy(circle, "Earth");
    
    set_attribute(earth, earth_a);
    set_scale(earth, 0.32, 0.32, 0.32);
    set_translate(earth, 0.0, -0.44, -1.72);
    set_bump_texture(earth, earth_a, "textures/earth.hr",
                     0.0, 1.0, 0.0, 1.0, 1, 1.0, -1.0);
    
    plant = insert_in_list(plant, earth);
    
    /* Leaves.								*/
    
    leaves_a = create_attribute("Leaves-Attributes");
    
    set_color(leaves_a, 0.25, 0.75, 0.25, 0.3, 0.7);
    set_reflectivity(leaves_a, 0.0, 2.0);
    
    leaves = read_obj("leaves.obj", "Leaves");
    
    set_attribute(leaves, leaves_a);
    set_scale(leaves, 0.2, 0.2, 0.2);
    set_translate(leaves, 0.0, -0.44, -1.6);
    set_domain_texture(leaves, leaves_a, "textures/leaf.hr",
                       0.0, 1.0, 0.0, 1.0, 1, 0.3, 0.7);
    
    plant = insert_in_list(plant, leaves);
    
    scene = insert_in_list(scene, plant);
    
    /* Scene Definition.						*/
    save_scene("tabernacle.md", "scene", scene);
    
    return (0);
}
